namespace CMSMicroservice.Application.RoleCQ.Commands.CreateNewRole;
public class CreateNewRoleCommandValidator : AbstractValidator<CreateNewRoleCommand>
{
    public CreateNewRoleCommandValidator()
    {
        RuleFor(model => model.Name)
            .NotEmpty();
        RuleFor(model => model.Title)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewRoleCommand>.CreateWithOptions((CreateNewRoleCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
